﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class DrawingObjectWarship : IDrawingObject
    {
        private DrawingWarship _warship = null;

        public DrawingObjectWarship(DrawingWarship warship)
        {
            _warship = warship;
        }
        public float Step => _warship?.Warship?.Step ?? 0;

        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _warship?.GetCurrentPosition() ?? default;
        }

        public string GetInfo()
        {
            return _warship?.GetDataForSave();
        }

        public void MoveObject(Direction direction)
        {
            _warship?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _warship.SetPosition(x, y, width, height);
        }

        void IDrawingObject.DrawningObject(Graphics g) => _warship.DrawTransport(g);

        public static IDrawingObject Create(string data) => new DrawingObjectWarship(data.CreateDrawningWarship());
    }
}
