﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class EntityAircraftCarrier : EntityWarship
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; set; }
        /// <summary>
        /// Признак наличия боковой площадки
        /// </summary>
        public bool BodyKit { get; private set; }
        /// <summary>
        /// Признак наличия рубки
        /// </summary>
        public bool Сabin { get; private set; }
        /// <summary>
        /// Признак наличия усиленного двигателя
        /// </summary>
        public bool SuperEngine { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес военного корабля</param>
        /// <param name="bodyColor">Цвет основной палубы</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия боковой площадки</param>
        /// <param name="сabin">Признак наличия рубки</param>
        /// <param name="superEngine">Признак наличия усиленного двигателя</param>
        public EntityAircraftCarrier(int speed, float weight, Color bodyColor, Color dopColor, bool bodyKit, bool сabin, bool superEngine) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            BodyKit = bodyKit;
            Сabin = сabin;
            SuperEngine = superEngine;
        }
    }
}
