﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    /// <summary>
    /// Расширение для класса DrawingWarship
    /// </summary>
    internal static class ExtentionWarship
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly char _separatorForObject = ':';
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        public static DrawingWarship CreateDrawningWarship(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingWarship(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 7)
            {
                return new DrawingAircraftCarrier(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                    Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                    Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawingWarship"></param>
        /// <returns></returns>
        public static string GetDataForSave(this DrawingWarship drawingWarship)
        {
            var warship = drawingWarship.Warship;
            var str = $"{warship.Speed}{_separatorForObject}{warship.Weight}{_separatorForObject}{warship.BodyColor.Name}";
            if (warship is not EntityAircraftCarrier aircraftCarrier)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{aircraftCarrier.DopColor.Name}{_separatorForObject}{aircraftCarrier.BodyKit}{_separatorForObject}{aircraftCarrier.Сabin}{_separatorForObject}{aircraftCarrier.SuperEngine}";
        }
    }
}
